﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Imaging;

namespace Carrousel2
{
 public partial class Page : UserControl
 {
  public Page()
  {
   InitializeComponent();
  }
  int nImageAtLeft = 1,
      nCellAtLeft = 0;

  Image[] tabCells;
  Image[] tabImages;
  string[] ts = { "Cezanne", "Delacroix", "Corot", "Millet", "Renoir", "Monet", "Courbet", "VanGogh" };
  int countImages, countCells = 6;
  bool bRtoL = true;   // Right to Left

  void RightArrow_MouseEnter(object sender, MouseEventArgs e)
  {
   if (bRtoL == true)
   {
    anim0.By = 110; anim1.By = 110; anim2.By = 110;
    anim3.By = 110; anim4.By = 110; anim5.By = 110;
    bRtoL = false;
   }
  }

  void LeftArrow_MouseEnter(object sender, MouseEventArgs e)
  {
   if (bRtoL == false)
   {
    anim0.By = -110; anim1.By = -110; anim2.By = -110;
    anim3.By = -110; anim4.By = -110; anim5.By = -110;
    bRtoL = true;
   }
  }

  void Page_MouseEnter(object sender, MouseEventArgs e)
  {
   stb.Pause();
  }

  void stb_Completed(object sender, EventArgs e)
  {
   if (bRtoL)
   {
    // la cellule à gauche est déplacée à la fin et contient une nouvelle image  
    int nextImageToBeLoaded = (nImageAtLeft + 5) % countImages;
    tabCells[nCellAtLeft].Source  = new BitmapImage(new Uri(tabImages[nextImageToBeLoaded].Tag+"Mini.jpg", UriKind.Relative));
    tabCells[nCellAtLeft].Tag = tabImages[nextImageToBeLoaded].Tag;
    tabCells[nCellAtLeft].SetValue(Canvas.LeftProperty, (double)550);
    nImageAtLeft = (nImageAtLeft + 1) % countImages;
    nCellAtLeft = (nCellAtLeft + 1) % countCells;
    stb.Begin();
   }
   if (bRtoL == false)
   {
    //  the cell at end is pushed in front with a new image
    int nCellAtEnd = (nCellAtLeft + countCells/* - 1*/) % countCells;
    int nextImageToBeLoaded = (nImageAtLeft + countImages - 1) % countImages;
    tabCells[nCellAtLeft].Source  = new BitmapImage(new Uri(tabImages[nextImageToBeLoaded].Tag+"Mini.jpg", UriKind.Relative));   
    tabCells[nCellAtEnd].SetValue(Canvas.LeftProperty, 0.0);
    tabCells[nCellAtLeft].Tag = tabImages[nextImageToBeLoaded].Tag; 
    nImageAtLeft = (nImageAtLeft + countImages - 1) % countImages;
    nCellAtLeft = (nCellAtLeft + countCells - 1) % countCells;
    stb.Begin();
   }
  }

  private void LayoutRoot_Loaded(object sender, RoutedEventArgs e)
  {
   try
   {
    countImages = ts.Length;
    tabImages = new Image[countImages];
    for (int i = 0; i < countImages; i++)
    {
     tabImages[i] = new Image();
     tabImages[i].Source = new BitmapImage(new Uri(ts[i] + "Mini.jpg", UriKind.Relative));
     tabImages[i].Tag = ts[i];
    }
    for (int i=0; i<countCells;i++)
    {
     Image img = (Image)FindName("img"+i);
     img.Source = new BitmapImage(new Uri(tabImages[i].Tag+"Mini.jpg", UriKind.Relative));
     img.Tag = tabImages[i].Tag;
    }

    tabCells = new Image[countCells]; // références à des éléments UI Image
    tabCells[0] = img0; tabCells[1] = img1; tabCells[2] = img2;
    tabCells[3] = img3; tabCells[4] = img4; tabCells[5] = img5;

    for (int i = 0; i < countCells; i++)
    {
     tabCells[i].MouseEnter += new MouseEventHandler(Page_MouseEnter);
     tabCells[i].MouseLeave += new MouseEventHandler(Page_MouseLeave);
     tabCells[i].MouseLeftButtonDown += new MouseButtonEventHandler(Page_MouseLeftButtonDown);
    }
    stb.Begin();
   }
   catch (Exception exc)
   {
    tb.Text = exc.Message;
   }
  }

  void Page_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
  {
   Image img = (Image)sender;
   string s = img.Tag.ToString();
   tb.Text = s;
   bigImage.Source = new BitmapImage(new Uri(s + ".jpg", UriKind.Relative));
   stbBig.Begin();
  }

  void Page_MouseLeave(object sender, MouseEventArgs e)
  {
   stb.Resume();
  }
 }
}
